## seqan-raptor 3.0.1+ds

=== CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.18)

find_path (RAPTOR_MODULE_PATH "raptor-config.cmake" HINTS "${CMAKE_CURRENT_LIST_DIR}/build_system/")
list (APPEND CMAKE_MODULE_PATH "${RAPTOR_MODULE_PATH}")

include (raptor-config-version)

project (raptor
         LANGUAGES CXX C
         VERSION "${RAPTOR_PROJECT_VERSION}"
         DESCRIPTION "Raptor -- A fast and space-efficient pre-filter for querying very large collections of nucleotide sequences"
         HOMEPAGE_URL "https://github.com/seqan/raptor"
)

find_package (Raptor REQUIRED HINTS ${RAPTOR_MODULE_PATH})

option (BUILD_RAPTOR "Enable building of Raptor." ON)

if (BUILD_RAPTOR)
    add_subdirectory (src)
endif ()

option (INSTALL_RAPTOR_HEADERS "Enable installation of Raptor headers." OFF)

if (INSTALL_RAPTOR_HEADERS)
    include (raptor-install)
    include (raptor-package)
endif ()

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set (CMAKE_INSTALL_BINDIR "bin") # For chopper

# CCache

include (../test/cmake/raptor_require_ccache.cmake)
raptor_require_ccache ()

# Dependency: Chopper
include (FetchContent)

FetchContent_Declare (raptor_chopper_project SOURCE_DIR "${RAPTOR_SUBMODULES_DIR}/chopper")

set (SEQAN3_SUBMODULES_DIR "${RAPTOR_SUBMODULES_DIR}")
set (CHOPPER_SUBMODULES_DIR
     "${RAPTOR_SUBMODULES_DIR}"
     CACHE STRING "Directory containing submodules."
)
set (CHOPPER_USE_CCACHE
     OFF
     CACHE BOOL "Use ccache if available."
)
set (CHOPPER_BUILD_DOC
     OFF
     CACHE BOOL "Build chopper documentation."
)
set (CHOPPER_BUILD_TEST
     OFF
     CACHE BOOL "Build chopper tests."
)
set (CHOPPER_INSTALL
     OFF
     CACHE BOOL "Install Chopper."
)

FetchContent_MakeAvailable (raptor_chopper_project)

# Dependency: xxHash
FetchContent_Declare (raptor_xxhash_project SOURCE_DIR "${RAPTOR_SUBMODULES_DIR}/xxHash" SOURCE_SUBDIR
                                            "cmake_unofficial"
)

set (XXHASH_BUILD_ENABLE_INLINE_API ON)
set (XXHASH_BUILD_XXHSUM OFF)
set (XXHASH_BUNDLED_MODE ON)
set (BUILD_SHARED_LIBS OFF)

FetchContent_MakeAvailable (raptor_xxhash_project)

# Shared interface
if (NOT TARGET raptor_interface)
    add_library ("raptor_interface" INTERFACE)
    target_link_libraries ("raptor_interface" INTERFACE raptor::raptor)
    target_compile_options ("raptor_interface" INTERFACE "-pedantic" "-Wall" "-Wextra")
endif ()

# Raptor library
if (NOT TARGET raptor_lib)
    add_library ("raptor_lib" INTERFACE)
    target_link_libraries ("raptor_lib"
                           INTERFACE "raptor_argument_parsing"
                                     "raptor_build"
                                     "raptor_build_hibf"
                                     "raptor_prepare"
                                     "raptor_search"
                                     "raptor_threshold"
                                     "raptor_upgrade"
                                     "raptor_layout"
    )
endif ()

# Raptor executable
if (NOT TARGET raptor)
    add_executable ("raptor" raptor.cpp)
    target_link_libraries ("raptor" PUBLIC "raptor_lib")
endif ()

install (TARGETS raptor DESTINATION "${CMAKE_INSTALL_BINDIR}")

add_subdirectory (argument_parsing)
add_subdirectory (build)
add_subdirectory (layout)
add_subdirectory (search)
add_subdirectory (prepare)
add_subdirectory (threshold)
add_subdirectory (upgrade)

=== lib/chopper/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

## CUSTOMISE

# Define the application name and version.
project (chopper VERSION 1.0.0)

## BUILD

# Make Release default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE
         Release
         CACHE STRING "Choose the type of build, options are: Debug Release Coverage RelWithDebInfo MinSizeRel." FORCE
    )
endif ()

set (CHOPPER_SUBMODULES_DIR
     "${CMAKE_CURRENT_LIST_DIR}/lib"
     CACHE STRING "Directory containing submodules."
)

# Flag checks
include (CheckCXXCompilerFlag)

check_cxx_compiler_flag ("-fopenmp" CHOPPER_HAS_OPENMP)
if (CHOPPER_HAS_OPENMP)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" CHOPPER_HAS_OPENMP_SIMD)
if (CHOPPER_HAS_OPENMP_SIMD)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd -DSIMDE_ENABLE_OPENMP")
endif ()

check_cxx_compiler_flag ("-fopenmp-simd" CHOPPER_SUPPRESS_GCC4_ABI)
if (CHOPPER_SUPPRESS_GCC4_ABI)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif ()

# Specify the directories where to store the built archives, libraries and executables
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set (CMAKE_INSTALL_LIBDIR
     "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}"
     CACHE STRING ""
)
set (CMAKE_INSTALL_BINDIR
     "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
     CACHE STRING ""
)

# Messages
string (ASCII 27 Esc)
set (FontBold "${Esc}[1m")
set (FontReset "${Esc}[m")

# Dependency: SeqAn3.
find_package (SeqAn3 REQUIRED QUIET HINTS ${CHOPPER_SUBMODULES_DIR}/seqan3/build_system)

# Allow to include CMake scripts from seqan3.
list (APPEND CMAKE_MODULE_PATH "${SEQAN3_CLONE_DIR}/test/cmake/")
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/test/cmake/")

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_COMPILER=${CMAKE_C_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_C_FLAGS=${CMAKE_C_FLAGS}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_LIBDIR=lib")

# Use ccache.
set (CHOPPER_USE_CCACHE
     ON
     CACHE BOOL "Use ccache if available."
)
if (CHOPPER_USE_CCACHE)
    include (chopper_require_ccache)
    chopper_require_ccache ()
endif ()

# Dependency: Sharg.
find_package (Sharg REQUIRED QUIET HINTS ${CHOPPER_SUBMODULES_DIR}/sharg-parser/build_system)

# Dependency: xxHash
set (CHOPPER_XXHASH_PATH "${PROJECT_BINARY_DIR}/lib/libxxhash.a")

if (EXISTS "${CHOPPER_XXHASH_PATH}")
    add_custom_target (xxhash_project)
else ()
    set (CHOPPER_XXHASH_ARGS "${SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS}")
    list (APPEND CHOPPER_XXHASH_ARGS "-DXXHASH_BUILD_XXHSUM=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "-DXXHASH_BUNDLED_MODE=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "-DBUILD_SHARED_LIBS=OFF")
    list (APPEND CHOPPER_XXHASH_ARGS "--no-warn-unused-cli")

    include (ExternalProject)
    ExternalProject_Add (xxhash_project
                         PREFIX xxhash_project
                         GIT_REPOSITORY https://github.com/Cyan4973/xxHash.git
                         GIT_TAG "f9155bd4c57e2270a4ffbb176485e5d713de1c9b"
                         CMAKE_ARGS "${CHOPPER_XXHASH_ARGS}"
                         SOURCE_SUBDIR cmake_unofficial
                         BUILD_BYPRODUCTS "${CHOPPER_XXHASH_PATH}"
                         UPDATE_DISCONNECTED 1
    )
endif ()

add_library (xxhash STATIC IMPORTED)
add_dependencies (xxhash xxhash_project)
set_target_properties (xxhash PROPERTIES IMPORTED_LOCATION "${CHOPPER_XXHASH_PATH}")
target_include_directories (xxhash INTERFACE "${PROJECT_BINARY_DIR}/include")

# Add the application.
set (CHOPPER_INSTALL
     ON
     CACHE BOOL "Install Chopper."
)

add_subdirectory (src)
message (STATUS "${FontBold}You can run `make` to build the application.${FontReset}")

## DOCUMENTATION

set (CHOPPER_BUILD_DOC
     ON
     CACHE BOOL "Build chopper documentation."
)
if (CHOPPER_BUILD_DOC)
    add_subdirectory (doc EXCLUDE_FROM_ALL)
endif ()

## TEST

set (CHOPPER_BUILD_TEST
     ON
     CACHE BOOL "Build chopper tests."
)
if (CHOPPER_BUILD_TEST)
    enable_testing ()
    add_subdirectory (test EXCLUDE_FROM_ALL)
endif ()

=== lib/tool_description_lib/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file.
# -----------------------------------------------------------------------------------------------------

# This file is called in the following scenarios
# 1. scenario: this file is at the root of a `cmake ..` call.
#       In this case we assume this project is compiled for packaging or testing.
# 2. scenario: another project is adding this directory via "add_subdirectory".
#       In this case we don't want any tests to be included.

cmake_minimum_required (VERSION 3.15)

# check if this is the root project (
if (NOT DEFINED PROJECT_NAME)
    set (CMAKE_CXX_STANDARD 17)
    set (CMAKE_CXX_STANDARD_REQUIRED ON)
    set (CMAKE_CXX_EXTENSIONS OFF)
    set (TDL_ROOT_PROJECT TRUE)
endif ()

include (cmake/version.cmake)

project (tdl
         LANGUAGES CXX
         VERSION "${TDL_VERSION}"
         DESCRIPTION "tdl -- tool description library")

include (tdl-config.cmake)

# Enable and include testing if this is a root directory
if (${TDL_ROOT_PROJECT})
    enable_testing ()
    file (GLOB TEST_CPP_FILES
          LIST_DIRECTORIES false
          RELATIVE ${PROJECT_SOURCE_DIR}
          CONFIGURE_DEPENDS src/test_tdl/*.cpp)
    add_executable (test_tdl ${TEST_CPP_FILES})
    target_link_libraries (test_tdl tdl::tdl)
    add_test (NAME test_tdl COMMAND test_tdl)
endif ()

=== lib/xxHash/Makefile ===
# ################################################################
# xxHash Makefile
# Copyright (C) 2012-2021 Yann Collet
#
# GPL v2 License
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# You can contact the author at:
#   - xxHash homepage: https://www.xxhash.com
#   - xxHash source repository: https://github.com/Cyan4973/xxHash
# ################################################################
# xxhsum: provides 32/64 bits hash of one or multiple files, or stdin
# ################################################################
Q = $(if $(filter 1,$(V) $(VERBOSE)),,@)

# Version numbers
SED ?= sed
SED_ERE_OPT ?= -E
LIBVER_MAJOR_SCRIPT:=`$(SED) -n '/define XXH_VERSION_MAJOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < xxhash.h`
LIBVER_MINOR_SCRIPT:=`$(SED) -n '/define XXH_VERSION_MINOR/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < xxhash.h`
LIBVER_PATCH_SCRIPT:=`$(SED) -n '/define XXH_VERSION_RELEASE/s/.*[[:blank:]]\([0-9][0-9]*\).*/\1/p' < xxhash.h`
LIBVER_MAJOR := $(shell echo $(LIBVER_MAJOR_SCRIPT))
LIBVER_MINOR := $(shell echo $(LIBVER_MINOR_SCRIPT))
LIBVER_PATCH := $(shell echo $(LIBVER_PATCH_SCRIPT))
LIBVER := $(LIBVER_MAJOR).$(LIBVER_MINOR).$(LIBVER_PATCH)

CFLAGS ?= -O3
DEBUGFLAGS+=-Wall -Wextra -Wconversion -Wcast-qual -Wcast-align -Wshadow \
            -Wstrict-aliasing=1 -Wswitch-enum -Wdeclaration-after-statement \
            -Wstrict-prototypes -Wundef -Wpointer-arith -Wformat-security \
            -Wvla -Wformat=2 -Winit-self -Wfloat-equal -Wwrite-strings \
            -Wredundant-decls -Wstrict-overflow=2
CFLAGS += $(DEBUGFLAGS) $(MOREFLAGS)
FLAGS   = $(CFLAGS) $(CPPFLAGS)
XXHSUM_VERSION = $(LIBVER)
UNAME := $(shell uname)

# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
else
EXT =
endif

ifeq ($(NODE_JS),1)
    # Link in unrestricted filesystem support
    LDFLAGS += -sNODERAWFS
    # Set flag to fix isatty() support
    CPPFLAGS += -DXSUM_NODE_JS=1
endif

# OS X linker doesn't support -soname, and use different extension
# see: https://developer.apple.com/library/mac/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html
ifeq ($(UNAME), Darwin)
	SHARED_EXT = dylib
	SHARED_EXT_MAJOR = $(LIBVER_MAJOR).$(SHARED_EXT)
	SHARED_EXT_VER = $(LIBVER).$(SHARED_EXT)
	SONAME_FLAGS = -install_name $(LIBDIR)/libxxhash.$(SHARED_EXT_MAJOR) -compatibility_version $(LIBVER_MAJOR) -current_version $(LIBVER)
else
	SONAME_FLAGS = -Wl,-soname=libxxhash.$(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT = so
	SHARED_EXT_MAJOR = $(SHARED_EXT).$(LIBVER_MAJOR)
	SHARED_EXT_VER = $(SHARED_EXT).$(LIBVER)
endif

LIBXXH = libxxhash.$(SHARED_EXT_VER)

XXHSUM_SRC_DIR = cli
XXHSUM_SPLIT_SRCS = $(XXHSUM_SRC_DIR)/xxhsum.c \
                    $(XXHSUM_SRC_DIR)/xsum_os_specific.c \
                    $(XXHSUM_SRC_DIR)/xsum_output.c \
                    $(XXHSUM_SRC_DIR)/xsum_sanity_check.c \
                    $(XXHSUM_SRC_DIR)/xsum_bench.c
XXHSUM_SPLIT_OBJS = $(XXHSUM_SPLIT_SRCS:.c=.o)
XXHSUM_HEADERS = $(XXHSUM_SRC_DIR)/xsum_config.h \
                 $(XXHSUM_SRC_DIR)/xsum_arch.h \
                 $(XXHSUM_SRC_DIR)/xsum_os_specific.h \
                 $(XXHSUM_SRC_DIR)/xsum_output.h \
                 $(XXHSUM_SRC_DIR)/xsum_sanity_check.h \
                 $(XXHSUM_SRC_DIR)/xsum_bench.h

## generate CLI and libraries in release mode (default for `make`)
.PHONY: default
default: DEBUGFLAGS=
default: lib xxhsum_and_links

.PHONY: all
all: lib xxhsum xxhsum_inlinedXXH

## xxhsum is the command line interface (CLI)
ifeq ($(DISPATCH),1)
xxhsum: CPPFLAGS += -DXXHSUM_DISPATCH=1
xxhsum: xxh_x86dispatch.o
endif
xxhsum: xxhash.o $(XXHSUM_SPLIT_OBJS)
	$(CC) $(FLAGS) $^ $(LDFLAGS) -o $@$(EXT)

xxhsum32: CFLAGS += -m32  ## generate CLI in 32-bits mode
xxhsum32: xxhash.c $(XXHSUM_SPLIT_SRCS) ## do not generate object (avoid mixing different ABI)
	$(CC) $(FLAGS) $^ $(LDFLAGS) -o $@$(EXT)

## dispatch only works for x86/x64 systems
dispatch: CPPFLAGS += -DXXHSUM_DISPATCH=1
dispatch: xxhash.o xxh_x86dispatch.o $(XXHSUM_SPLIT_SRCS)
	$(CC) $(FLAGS) $^ $(LDFLAGS) -o $@$(EXT)

xxhash.o: xxhash.c xxhash.h
xxhsum.o: $(XXHSUM_SRC_DIR)/xxhsum.c $(XXHSUM_HEADERS) \
    xxhash.h xxh_x86dispatch.h
xxh_x86dispatch.o: xxh_x86dispatch.c xxh_x86dispatch.h xxhash.h

.PHONY: xxhsum_and_links
xxhsum_and_links: xxhsum xxh32sum xxh64sum xxh128sum

xxh32sum xxh64sum xxh128sum: xxhsum
	ln -sf $<$(EXT) $@$(EXT)

xxhsum_inlinedXXH: CPPFLAGS += -DXXH_INLINE_ALL
xxhsum_inlinedXXH: $(XXHSUM_SPLIT_SRCS)
	$(CC) $(FLAGS) $< -o $@$(EXT)


# library

libxxhash.a: ARFLAGS = rcs
libxxhash.a: xxhash.o
	$(AR) $(ARFLAGS) $@ $^

$(LIBXXH): LDFLAGS += -shared
ifeq (,$(filter Windows%,$(OS)))
$(LIBXXH): CFLAGS += -fPIC
endif
ifeq ($(DISPATCH),1)
$(LIBXXH): xxh_x86dispatch.c
endif
$(LIBXXH): xxhash.c
	$(CC) $(FLAGS) $^ $(LDFLAGS) $(SONAME_FLAGS) -o $@
	ln -sf $@ libxxhash.$(SHARED_EXT_MAJOR)
	ln -sf $@ libxxhash.$(SHARED_EXT)

.PHONY: libxxhash
libxxhash:  ## generate dynamic xxhash library
libxxhash: $(LIBXXH)

.PHONY: lib
lib:  ## generate static and dynamic xxhash libraries
lib: libxxhash.a libxxhash

# helper targets

AWK  = awk
GREP = grep
SORT = sort
NM   = nm

.PHONY: list
list:  ## list all Makefile targets
	$(Q)$(MAKE) -pRrq -f $(lastword $(MAKEFILE_LIST)) : 2>/dev/null | $(AWK) -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' | $(SORT) | egrep -v -e '^[^[:alnum:]]' -e '^$@$$' | xargs

.PHONY: help
help:  ## list documented targets
	$(Q)$(GREP) -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | \
	$(SORT) | \
	$(AWK) 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

.PHONY: clean
clean:  ## remove all build artifacts
	$(Q)$(RM) -r *.dSYM   # Mac OS-X specific
	$(Q)$(RM) core *.o *.obj *.$(SHARED_EXT) *.$(SHARED_EXT).* *.a libxxhash.pc
	$(Q)$(RM) xxhsum$(EXT) xxhsum32$(EXT) xxhsum_inlinedXXH$(EXT) dispatch$(EXT)
	$(Q)$(RM) xxhsum.wasm xxhsum.js xxhsum.html
	$(Q)$(RM) xxh32sum$(EXT) xxh64sum$(EXT) xxh128sum$(EXT)
	$(Q)$(RM) $(XXHSUM_SRC_DIR)/*.o $(XXHSUM_SRC_DIR)/*.obj
	$(MAKE) -C tests clean
	$(MAKE) -C tests/bench clean
	$(MAKE) -C tests/collisions clean
	@echo cleaning completed


# =================================================
# tests
# =================================================

# make check can be run with cross-compiled binaries on emulated environments (qemu user mode)
# by setting $(RUN_ENV) to the target emulation environment
.PHONY: check
check: xxhsum test_sanity   ## basic tests for xxhsum CLI, set RUN_ENV for emulated environments
	# stdin
	# If you get "Wrong parameters" on Emscripten+Node.js, recompile with `NODE_JS=1`
	$(RUN_ENV) ./xxhsum$(EXT) < xxhash.c
	# multiple files
	$(RUN_ENV) ./xxhsum$(EXT) xxhash.*
	# internal bench
	$(RUN_ENV) ./xxhsum$(EXT) -bi0
	# long bench command
	$(RUN_ENV) ./xxhsum$(EXT) --benchmark-all -i0
	# bench multiple variants
	$(RUN_ENV) ./xxhsum$(EXT) -b1,2,3 -i0
	# file bench
	$(RUN_ENV) ./xxhsum$(EXT) -bi0 xxhash.c
	# 32-bit
	$(RUN_ENV) ./xxhsum$(EXT) -H0 xxhash.c
	# 128-bit
	$(RUN_ENV) ./xxhsum$(EXT) -H2 xxhash.c
	# XXH3 (enforce BSD style)
	$(RUN_ENV) ./xxhsum$(EXT) -H3 xxhash.c | grep "XXH3"
	# request incorrect variant
	$(RUN_ENV) ./xxhsum$(EXT) -H9 xxhash.c ; test $$? -eq 1
	@printf "\n .......   checks completed successfully   ....... \n"

.PHONY: test-unicode
test-unicode:
	$(MAKE) -C tests test_unicode

.PHONY: test_sanity
test_sanity:
	$(MAKE) -C tests test_sanity

.PHONY: test-mem
VALGRIND = valgrind --leak-check=yes --error-exitcode=1
test-mem: RUN_ENV = $(VALGRIND)
test-mem: xxhsum check

.PHONY: test32
test32: xxhsum32
	@echo ---- test 32-bit ----
	./xxhsum32 -bi0 xxhash.c

TEST_FILES = xxhsum$(EXT) xxhash.c xxhash.h
.PHONY: test-xxhsum-c
test-xxhsum-c: xxhsum
	# xxhsum to/from pipe
	./xxhsum $(TEST_FILES) | ./xxhsum -c -
	./xxhsum -H0 $(TEST_FILES) | ./xxhsum -c -
	# xxhsum -c is unable to verify checksum of file from STDIN (#470)
	./xxhsum < README.md > .test.README.md.xxh
	./xxhsum -c .test.README.md.xxh < README.md
	# xxhsum -q does not display "Loading" message into stderr (#251)
	! ./xxhsum -q $(TEST_FILES) 2>&1 | grep Loading
	# xxhsum does not display "Loading" message into stderr either
	! ./xxhsum $(TEST_FILES) 2>&1 | grep Loading
	# Check that xxhsum do display filename that it failed to open.
	LC_ALL=C ./xxhsum nonexistent 2>&1 | grep "Error: Could not open 'nonexistent'"
	# xxhsum to/from file, shell redirection
	./xxhsum $(TEST_FILES) > .test.xxh64
	./xxhsum --tag $(TEST_FILES) > .test.xxh64_tag
	./xxhsum --little-endian $(TEST_FILES) > .test.le_xxh64
	./xxhsum --tag --little-endian $(TEST_FILES) > .test.le_xxh64_tag
	./xxhsum -H0 $(TEST_FILES) > .test.xxh32
	./xxhsum -H0 --tag $(TEST_FILES) > .test.xxh32_tag
	./xxhsum -H0 --little-endian $(TEST_FILES) > .test.le_xxh32
	./xxhsum -H0 --tag --little-endian $(TEST_FILES) > .test.le_xxh32_tag
	./xxhsum -H2 $(TEST_FILES) > .test.xxh128
	./xxhsum -H2 --tag $(TEST_FILES) > .test.xxh128_tag
	./xxhsum -H2 --little-endian $(TEST_FILES) > .test.le_xxh128
	./xxhsum -H2 --tag --little-endian $(TEST_FILES) > .test.le_xxh128_tag
	./xxhsum -H3 $(TEST_FILES) > .test.xxh3
	./xxhsum -H3 --tag $(TEST_FILES) > .test.xxh3_tag
	./xxhsum -H3 --little-endian $(TEST_FILES) > .test.le_xxh3
	./xxhsum -H3 --tag --little-endian $(TEST_FILES) > .test.le_xxh3_tag
	./xxhsum -c .test.xxh*
	./xxhsum -c --little-endian .test.le_xxh*
	./xxhsum -c .test.*_tag
	# read list of files from stdin
	./xxhsum -c < .test.xxh32
	./xxhsum -c < .test.xxh64
	./xxhsum -c < .test.xxh128
	./xxhsum -c < .test.xxh3
	cat .test.xxh* | ./xxhsum -c -
	# check variant with '*' marker as second separator
	$(SED) 's/  / \*/' .test.xxh32 | ./xxhsum -c
	# bsd-style output
	./xxhsum --tag xxhsum* | $(GREP) XXH64
	./xxhsum --tag -H0 xxhsum* | $(GREP) XXH32
	./xxhsum --tag -H1 xxhsum* | $(GREP) XXH64
	./xxhsum --tag -H2 xxhsum* | $(GREP) XXH128
	./xxhsum --tag -H3 xxhsum* | $(GREP) XXH3
	./xxhsum       -H3 xxhsum* | $(GREP) XXH3  # --tag is implicit for H3
	./xxhsum --tag -H32 xxhsum* | $(GREP) XXH32
	./xxhsum --tag -H64 xxhsum* | $(GREP) XXH64
	./xxhsum --tag -H128 xxhsum* | $(GREP) XXH128
	./xxhsum --tag -H0 --little-endian xxhsum* | $(GREP) XXH32_LE
	./xxhsum --tag -H1 --little-endian xxhsum* | $(GREP) XXH64_LE
	./xxhsum --tag -H2 --little-endian xxhsum* | $(GREP) XXH128_LE
	./xxhsum       -H3 --little-endian xxhsum* | $(GREP) XXH3_LE
	./xxhsum --tag -H32 --little-endian xxhsum* | $(GREP) XXH32_LE
	./xxhsum --tag -H64 --little-endian xxhsum* | $(GREP) XXH64_LE
	./xxhsum --tag -H128 --little-endian xxhsum* | $(GREP) XXH128_LE
	# check bsd-style
	./xxhsum --tag xxhsum* | ./xxhsum -c
	./xxhsum --tag -H32 --little-endian xxhsum* | ./xxhsum -c
	# xxhsum -c warns improperly format lines.
	echo '12345678 ' >>.test.xxh32
	./xxhsum -c .test.xxh32 | $(GREP) improperly
	echo '123456789  file' >>.test.xxh64
	./xxhsum -c .test.xxh64 | $(GREP) improperly
	# Expects "FAILED"
	echo "0000000000000000  LICENSE" | ./xxhsum -c -; test $$? -eq 1
	echo "00000000  LICENSE" | ./xxhsum -c -; test $$? -eq 1
	# Expects "FAILED open or read"
	echo "0000000000000000  test-expects-file-not-found" | ./xxhsum -c -; test $$? -eq 1
	echo "00000000  test-expects-file-not-found" | ./xxhsum -c -; test $$? -eq 1
	@$(RM) .test.*

.PHONY: test-filename-escape
test-filename-escape:

=== src/argument_parsing/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

if (NOT TARGET raptor_argument_parsing)
    # Fallback to these values if there is no git or no git repository
    set (RAPTOR_COMMIT_DATE
         "Unavailable"
         CACHE STRING
               "Set to provide a commit date if git is not available or the source directory is not a git repository."
    )
    set (RAPTOR_COMMIT_HASH
         "commit unavailable"
         CACHE STRING
               "Set to provide a commit hash if git is not available or the source directory is not a git repository."
    )

    # Extract git commit hash and date
    find_package (Git QUIET)

    if (GIT_FOUND)
        execute_process (COMMAND "${GIT_EXECUTABLE}" -C "${CMAKE_CURRENT_LIST_DIR}" rev-parse
                         WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}"
                         RESULT_VARIABLE is_no_git_repository
                         ERROR_QUIET
        )

        if (NOT is_no_git_repository)
            execute_process (COMMAND "${GIT_EXECUTABLE}" describe --always --abbrev=40 --dirty
                             WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}"
                             OUTPUT_VARIABLE RAPTOR_COMMIT_HASH
                             ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
            )

            execute_process (COMMAND "${GIT_EXECUTABLE}" log -1 --format=%ad --date=short
                             WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}"
                             OUTPUT_VARIABLE RAPTOR_COMMIT_DATE
                             ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
            )
        endif ()
    endif ()

    add_library ("raptor_argument_parsing" STATIC
                 ../build/hibf/parse_chopper_pack_line.cpp
                 build_parsing.cpp
                 compute_bin_size.cpp
                 init_shared_meta.cpp
                 parse_bin_path.cpp
                 prepare_parsing.cpp
                 search_parsing.cpp
                 upgrade_parsing.cpp
    )

    target_compile_definitions ("raptor_argument_parsing"
                                PUBLIC "-DRAPTOR_VERSION=\"${PACKAGE_VERSION} (${RAPTOR_COMMIT_HASH})\""
                                       "-DRAPTOR_DATE=\"${RAPTOR_COMMIT_DATE}\""
    )

    target_link_libraries ("raptor_argument_parsing" PUBLIC "raptor_interface")
endif ()

=== src/layout/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.15)

if (NOT TARGET raptor_layout)
    add_library ("raptor_layout" STATIC raptor_layout.cpp)

    target_link_libraries ("raptor_layout" PUBLIC "raptor_interface" "chopper_layout_lib" xxHash::xxhash)
endif ()

=== src/prepare/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

if (NOT TARGET raptor_prepare)
    add_library ("raptor_prepare" STATIC compute_minimiser.cpp)

    target_link_libraries ("raptor_prepare" PUBLIC "raptor_interface")
endif ()

=== src/search/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

if (NOT TARGET raptor_search)
    add_library ("raptor_search" STATIC raptor_search.cpp search_hibf.cpp search_ibf.cpp search_partitioned_ibf.cpp)

    target_link_libraries ("raptor_search" PUBLIC "raptor_interface")
endif ()

=== src/threshold/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

if (NOT TARGET raptor_threshold)
    add_library ("raptor_threshold" STATIC multiple_error_model.cpp one_error_model.cpp one_indirect_error_model.cpp
                                           pascal_row.cpp precompute_correction.cpp precompute_threshold.cpp
    )

    target_link_libraries ("raptor_threshold" PUBLIC "raptor_interface")
endif ()

=== src/upgrade/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.18)

if (NOT TARGET raptor_upgrade)
    add_library ("raptor_upgrade" STATIC raptor_upgrade.cpp)
    target_link_libraries ("raptor_upgrade" PUBLIC "raptor_interface")
endif ()

=== test/coverage/CMakeLists.txt ===
# --------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2023, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2023, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/raptor/blob/main/LICENSE.md
# --------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.18)

project (raptor_test_coverage LANGUAGES CXX C)

include (../cmake/raptor_require_ccache.cmake)
raptor_require_ccache ()

# Add a custom build type: Coverage

set (CMAKE_CXX_FLAGS_COVERAGE
     "${CMAKE_CXX_FLAGS_DEBUG} --coverage -fprofile-arcs -ftest-coverage ${RAPTOR_FPROFILE_ABS_PATH}"
     CACHE STRING "Flags used by the C++ compiler during coverage builds." FORCE
)
set (CMAKE_C_FLAGS_COVERAGE
     "${CMAKE_C_FLAGS_DEBUG} --coverage -fprofile-arcs -ftest-coverage ${RAPTOR_FPROFILE_ABS_PATH}"
     CACHE STRING "Flags used by the C compiler during coverage builds." FORCE
)
set (CMAKE_EXE_LINKER_FLAGS_COVERAGE
     "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-lgcov"
     CACHE STRING "Flags used for linking binaries during coverage builds." FORCE
)
set (CMAKE_SHARED_LINKER_FLAGS_COVERAGE
     "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -Wl,-lgcov"
     CACHE STRING "Flags used by the shared libraries linker during coverage builds." FORCE
)

mark_as_advanced (CMAKE_CXX_FLAGS_COVERAGE CMAKE_C_FLAGS_COVERAGE CMAKE_EXE_LINKER_FLAGS_COVERAGE
                  CMAKE_SHARED_LINKER_FLAGS_COVERAGE
)

enable_testing ()
add_subdirectory ("../unit" "${CMAKE_CURRENT_BINARY_DIR}/unit")

=== debian/changelog ===
seqan-raptor (3.0.1+ds-5) unstable; urgency=medium

  * d/tests/run-unit-test: also use -DRAPTOR_NATIVE_BUILD=OFF here

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 06 Sep 2023 15:04:40 +0200

seqan-raptor (3.0.1+ds-4) unstable; urgency=medium

  * d/tests/*: added post-install running of the CLI tests againsted the
    installed binary.
  * d/rules: better clean up after ourselves.
  * Update doxygen patch with upstream's help for better doxygen 1.9.8
    compat. Closes: #1051156
  * d/control: therefore xelatex is no longer needed to build the docs.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 05 Sep 2023 13:59:30 +0200

seqan-raptor (3.0.1+ds-3) unstable; urgency=medium

  * d/rules,d/tests/*: whoops, more work needed to build & run all the available
    tests.
  * Add "-O3" to the build-flags, to match "-DCMAKE_BUILD_TYPE=Release".
  * d/tests/cwl: save results to $AUTOPKGTEST_ARTIFACTS, use
    $AUTOPKGTEST_TMP for temporary files.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 22 Aug 2023 13:14:50 +0200

seqan-raptor (3.0.1+ds-2) unstable; urgency=medium

  * Fix docs only build
  * d/clean: remove doc_build to fix "fails to build source after
    successful build". Closes: #1048716
  * r/rules: allow for existing "doc_build" directory. Fixes "Fails to
    build binary packages again after successful build". Closes:
    #1049768
  * d/rules: export and install the CWL descriptions to
    /usr/share/commonwl/raptor-*.cwl
  * d/control: suggest the virtual package cwl-runner.
  * d/clean: clean up the generated manpages and CWL descriptions.
  * d/tests/: add CWL-based autopkgtest.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 21 Aug 2023 14:17:58 +0200

seqan-raptor (3.0.1+ds-1) unstable; urgency=medium

  * New upstream version
  * Set upstream metadata fields: Bug-Submit.
  * Removed 3 patches that are part of the new release. Refreshed the
    remaining patches.
  * d/control: add new build-dep: libyaml-cpp-dev

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 17 Aug 2023 16:04:15 +0200

seqan-raptor (3.0.0+ds-3) unstable; urgency=medium

  * d/rules: set -DRAPTOR_STRIP_BINARY=OFF to prevent binary striping

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Jul 2023 14:16:30 +0200

=== debian/control ===
Source: seqan-raptor
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libseqan3-dev (>= 3.3.0~rc.1),
               libgtest-dev,
               libxxhash-dev,
               libcereal-dev,
               libsimde-dev,
               libyaml-cpp-dev,
               pkg-config,
               doxygen <!nodoc>,
               cppreference-doc-en-html <!nodoc>,
               texlive-font-utils <!nodoc>,
               texlive-latex-base <!nodoc>,
               texlive-latex-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
               texlive-plain-generic <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               ghostscript <!nodoc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/seqan-raptor
Vcs-Git: https://salsa.debian.org/med-team/seqan-raptor.git
Homepage: https://github.com/seqan/raptor
Rules-Requires-Root: no

Package: seqan-raptor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: cwl-runner
Description: pre-filter for querying very large collections of nucleotide sequences
 Raptor is a system for approximately searching many queries such as
 next-generation sequencing reads or transcripts in large collections of
 nucleotide sequences. Raptor uses winnowing minimizers to define a set of
 representative k-mers, an extension of the interleaved Bloom filters (IBFs) as
 a set membership data structure and probabilistic thresholding for minimizers.
 This approach allows compression and partitioning of the IBF to enable the
 effective use of secondary memory.

Package: seqan-raptor-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Build-Profiles: <!nodoc>
Multi-Arch: foreign
Description: HTML & PDF documentation for seqan-raptor and its APIs
 Raptor is a system for approximately searching many queries such as
 next-generation sequencing reads or transcripts in large collections of
 nucleotide sequences. Raptor uses winnowing minimizers to define a set of
 representative k-mers, an extension of the interleaved Bloom filters (IBFs) as
 a set membership data structure and probabilistic thresholding for minimizers.
 This approach allows compression and partitioning of the IBF to enable the
 effective use of secondary memory.
 .
 This package contains Raptor's docs (HTML & PDF).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND=-I/usr/include/seqan3/submodules/sdsl-lite/include/ -I/usr/include/simde -I${CURDIR}/lib/sharg-parser/include/ -I${CURDIR}/lib/submodules/lemon/include/
export DEB_CFLAGS_MAINT_APPEND=-O3
export DEB_CXXFLAGS_MAINT_APPEND=-O3
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_configure --sourcedirectory=test/documentation --builddirectory doc_build -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF -Dbuild_search=ON
endif

override_dh_auto_configure-arch:
	dh_auto_configure -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_configure --sourcedirectory=test/unit --builddirectory build_unit -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF
	#dh_auto_configure --sourcedirectory=test/performance --builddirectory build_performance -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF
	#dh_auto_configure --sourcedirectory=test/header --builddirectory build_header -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF
	dh_auto_configure --sourcedirectory=test/snippet --builddirectory build_snippet -- -DRAPTOR_NATIVE_BUILD=OFF -DRAPTOR_SUBMODULES_DIR=$(CURDIR)/lib -DRAPTOR_STRIP_BINARY=OFF
endif

override_dh_auto_build-arch:
	dh_auto_build --arch
	obj-*/bin/raptor --export-help man > debian/raptor.1
	obj-*/bin/raptor build --export-help man > debian/raptor-build.1
	obj-*/bin/raptor search --export-help man > debian/raptor-search.1
	obj-*/bin/raptor layout --export-help man > debian/raptor-layout.1
	obj-*/bin/raptor prepare --export-help man > debian/raptor-prepare.1
	obj-*/bin/raptor upgrade --export-help man > debian/raptor-upgrade.1
	obj-*/bin/raptor build --export-help cwl > debian/raptor-build.cwl
	obj-*/bin/raptor search --export-help cwl > debian/raptor-search.cwl
	obj-*/bin/raptor layout --export-help cwl > debian/raptor-layout.cwl
	obj-*/bin/raptor prepare --export-help cwl > debian/raptor-prepare.cwl
	obj-*/bin/raptor upgrade --export-help cwl > debian/raptor-upgrade.cwl
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_build --arch --builddirectory build_unit
	#dh_auto_build --arch --builddirectory build_performance
	#dh_auto_build --arch --builddirectory build_header
	dh_auto_build --arch --builddirectory build_snippet
endif

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_build --indep --builddirectory doc_build
	cd doc_build/latex && $(MAKE)
endif

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_test --arch --builddirectory build_unit
	#dh_auto_test --arch --builddirectory build_performance
	#dh_auto_test --arch --builddirectory build_header
	dh_auto_test --arch --builddirectory build_snippet
endif

override_dh_auto_test-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_test --builddirectory doc_build
endif
endif

override_dh_auto_install-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_install --indep --builddir doc_build
endif

override_dh_auto_clean-arch:
	dh_auto_clean
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_clean --sourcedirectory=test/unit --builddirectory build_unit
	#dh_auto_clean --sourcedirectory=test/performance --builddirectory build_performance
	#dh_auto_clean --sourcedirectory=test/header --builddirectory build_header
	dh_auto_clean --sourcedirectory=test/snippet --builddirectory build_snippet
endif

override_dh_auto_clean-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	dh_auto_clean --indep --builddir doc_build
endif

override_dh_missing:
	dh_missing --list-missing

=== debian/tests/control ===
Tests: cwl
Depends: @, cwltool, python3-setuptools, nodejs
Restrictions: allow-stderr

Tests: run-unit-test
Depends: @, cmake, g++, patch, libseqan3-dev, libyaml-cpp-dev, libxxhash-dev, pkg-config, libgtest-dev, libsimde-dev
Restrictions: allow-stderr
